#include "lll_uses.hh"

int main() {
  ff_vector f0(5);
  f0(0) = 1.;
  f0(1) = 0.;
  f0(2) = -1.;
  f0(3) = 0.;
  f0(4) = 0.;

  ff_matrix fis(3, 5);
  fis(0, 0) = 1.;
  fis(0, 1) = 2.;
  fis(0, 2) = 3.;
  fis(0, 3) = 4.;
  fis(0, 4) = 1.;

  fis(1, 0) = 1.;
  fis(1, 1) = 3.;
  fis(1, 2) = 4.;
  fis(1, 3) = 1.;
  fis(1, 4) = 0.;

  fis(2, 0) = 1.;
  fis(2, 1) = 5.;
  fis(2, 2) = 7.;
  fis(2, 3) = 9.;
  fis(2, 4) = 3.;

  ff_vector v(5);
  v(0) = 13.869687164;
  v(1) = 57.5273127871;
  v(2) = 79.5182413665;
  v(3) = 97.8123130932;
  v(4) = 31.6879557815;

  qq_vector y = near_vector(1000, v, f0, fis);

  ff_vector w = f0 + prod(qq_to_ff_vector(y), fis);
  std::cout << "v = " << v << std::endl;
  std::cout << "w = " << w << std::endl;
  std::cout << "diff: " << norm_2(v-w) << std::endl << std::endl;
}
